#include <R.h>
#include <math.h>
#include <Rmath.h>


void LLstep1(int*X,double*W,double*A,double*B,double*y,double*w,double*LL,int*N,int*I,int*K,int*ii){
    double l=1;
    for(int j=0;j<N[0];j++){
        for(int k=0;k<K[0];k++){
            l=0;
            for(int i=0;i<I[0];i++){
                if(i!=ii[0]){
                    if(X[j+i*N[0]]!=9){
                        LL[j+k*N[0]]=LL[j+k*N[0]]+pnorm(A[j+i*N[0]]*y[k]+B[j+i*N[0]],0,1,X[j+i*N[0]],1);
                    }
                }
            
            }
        }
    }
}

void LLstep2(int*X,double*W,double*a,double*b,double*y,double*w,double*l,double*LL,int*N,int*I,int*K,int*ii){
    double L=0;
    LL[0]=0;
    for(int j=0;j<N[0];j++){
        L=0;
        for(int k=0;k<K[0];k++){
        
            if(ii[0]<I[0]){
                if(X[j+ii[0]*N[0]]!=9){
                    l[j+k*N[0]]=l[j+k*N[0]]+W[j]*pnorm(a[0]*y[k]+b[0],0,1,X[j+ii[0]*N[0]],1);
                }}
            l[j+k*N[0]]=exp(l[j+k*N[0]]);
            L=L+w[k]*l[j+k*N[0]];
        }
        LL[0]=LL[0]+log(L);
    }

}

void parametric(int*X,double*Y,double*Z,double*t,double*a,double*b,double*A,double*B,int*N,int*I,int*R){/* Z should always have a zero before everything*/
    GetRNGstate();
    double M=0;
    double S=0;
    double u=0;
    for(int j=0;j<N[0];j++){
        for(int i=0;i<I[0];i++){
	    A[i]=a[i];
            B[i]=b[i];
	    if(R[0]>0){
            	for(int r=0;r<R[0];r++){
			A[i]=A[i]+a[i+(r+1)*I[0]]*Z[1+j+i*N[0]+r*(I[0]*N[0])];
			B[i]=B[i]+b[i+(r+1)*I[0]]*Z[1+j+i*N[0]+r*(I[0]*N[0])];
		}
            }			
            if(X[j+i*N[0]]==1){
                u=runif(pnorm(0,A[i]*t[j]+B[i],1,1,0),1);
            }
            if(X[j+i*N[0]]==0){
                u=runif(0,pnorm(0,A[i]*t[j]+B[i],1,1,0));
            }
            Y[j+i*N[0]]=qnorm(u,A[i]*t[j]+B[i],1,1,0);
        }
	M=0;
        S=1;
        for(int i=0;i<I[0];i++){
            M=M+A[i]*(Y[j+i*N[0]]-B[i]);
            S=S+A[i]*A[i];
        }
        S=1/S;
        M=M*S;
        t[j]=rnorm(M,sqrt(S));
    }
    PutRNGstate();
}


void LL(int*X,double*a,double*b,double*y,double*w,int*N,int*I,int*K,double*L){
    double l=0;
    for(int j=0;j<N[0];j++){
        L[j]=0;
        for(int g=0;g<K[0];g++){
            l=1;
            for(int i=0;i<I[0];i++){
                l=l*pnorm(a[j+i*N[0]]*y[g]+b[j+i*N[0]],0,1,X[j+i*N[0]],0);
            }
            L[j]=L[j]+w[g]*l;
        }
        L[j]=log(L[j]);
    }
}

